#[macro_use]
extern crate criterion;
extern crate adversary;

use criterion::{criterion_group, criterion_main, Criterion};

fn bench_search(c: &mut Criterion) {
    pyo3::prepare_freethreaded_python();
    pyo3::Python::with_gil(|_py| {
        let obj = adversary::Prover::py_new(
            "= (ham x) k".to_string(),
            "= (ham y) (+ k 1)".to_string(),
            "<= ham (^ x y) p".to_string(),
        )
        .unwrap();
        c.bench_function("search", |b| {
            b.iter(|| criterion::black_box(obj.find_bounds(10, 5, 3)));
        });
    })
}

criterion_group!(search, bench_search);
criterion_main!(search);